#
#  This example 
#  gets a list of jobs of a user
#  and enables all jobs
#
#

import os
import sys

mod_dir = os.path.dirname(__file__)
if mod_dir not in sys.path:
    sys.path.append(mod_dir)

from rr_python_utils.load_rrlib import rrLib  # module libpyRR3 for python 3, libpyRR2 for python 2
import rr_python_utils.connection as rr_connect
import rrJob



def connectToServer():
    print("Connecting to rrServer by using a convenience function...")
    tcp = rr_connect.server_connect()
    return tcp
    
def get_user_jobs(tcp, job_user_name=""):
    print("Getting a list of jobs...")
    tcp.jobList_SetFilter3(job_user_name, "", "", 0, "", False, rrLib._filterIDs.isAll)
    jobs_list = []

    if not tcp.jobList_GetBasic():
        print("Error jobList_GetBasic: " + tcp.errorMessage())
        return jobs_list

    jobs_count = tcp.jobs.getMaxJobsFiltered()
    if jobs_count == 0:
        print("No jobs of user '{0}'".format(job_user_name))
        return jobs_list

    for i in range(jobs_count):
        job_id = tcp.jobs.getJobMinInfo_filterQueue(i).ID
        jobs_list.append(job_id)
    return jobs_list


tcp= connectToServer()

jobs_list=[]
#get all jobs of user renderfarm:
jobs_list=get_user_jobs(tcp, "renderfarm")

if len(jobs_list) != 0:
    print("Sending Command 'Enable' for jobs of user ...")
    if not tcp.jobSendCommand(jobs_list, rrJob._LogMessage.lEnable, 0):
        print("Error jobSendCommand: " + tcp.errorMessage())



print("\n\n--- DONE ---\n\n")
